# coding: UTF-8

import requests
from bs4 import BeautifulSoup
import time
import codecs
import re
import sys
import argparse

parser = argparse.ArgumentParser()

parser.add_argument('file1', metavar='FILE1', nargs='?', action='store', help='input file name')
parser.add_argument('file2', metavar='FILE2', nargs='?', action='store', help='output file name')
parser.add_argument('-f', '--full', dest='full', action='store_true', help='output full contents')
parser.add_argument('-m', '--minimum', dest='minimum', action='store_true', help='output minimum contents')

args = parser.parse_args()

headers = requests.utils.default_headers()
headers.update(
    {
        'User-Agent': 'Mozilla/4.0 (compatible; MSIE 5.5; Windows NT)', 
    }
)


def get_translation(word):
    global word_head,word_pos,word_definition,word_quote 
    base_url = "http://www.collinsdictionary.com/us/dictionary/english/"
    url = base_url + word
    #print "\n" +  "Search Word : " + word + "\r" + "URL : " + url
    print ("\n" +  "Search Word : " + word)
    print ("\r" + "URL : " + url)

    ret = requests.get(url, headers=headers )
    soup = BeautifulSoup(ret.content,"lxml")

    block = soup.findAll('div', {'data-type-block':'Learner'})

    if block:
        block_num = len(block) - 1

        for def_num in range(0, len(block)):
            block = soup.findAll('div', {'data-type-block':'Learner'})[def_num]
            word_head =  block.find('span', {'class':'orth'}).text

#            if re.compile(word,re.IGNORECASE).match(word_head) != None:
            if word_head == word.strip():
                   print ("** Found! **")
                   word_pos =  block.find('span', {'class':'pos'})
                   if word_pos:
                       word_pos = block.find('span', {'class':'pos'}).text.replace('\n',' ')
                   else:
                       word_pos = "(none)"

                   word_definition =  block.find('div', {'class':'def'})
                   if word_definition:
                      word_definition =  word_definition.text.replace('\n',' ')
                      matched = re.search(r"of [a-zA-Z\s]+1\.", word_definition)
                      if matched:
                          word_definition = word_definition.replace('1.','.')
                   else:
                       word_definition = "(none)"

                   word_quote = block.find('span', {'class':'quote'})
                   if word_quote:
                       word_quote = block.find('span', {'class':'quote'}).text
                   else:
                       word_quote = "(none)"
                   break

#            elif re.compile(word.strip(),re.IGNORECASE).match(word_head) == None and def_num == block_num:
            elif word_head != word.strip() and def_num == block_num:
                   print ("** No result in the Collins Dictionary **")
                   word_pos = "(none)"
                   word_definition = "(none)"
                   word_quote = "(none)"
                   break

    else:
        print ("** there is no word in the dictionary **")
        word_pos = "(none)"
        word_definition = "(none)"
        word_quote = "(none)"

    return word_head, word_pos, word_definition, word_quote


if __name__ == "__main__":

    if args.file1 == None or args.file2 == None:
        print ("\n" + ("Command format is wrong."))
        quit()

    #f1 = open(args.file1)
    f1 = open(args.file1, 'r')
    f2 = codecs.open (args.file2, 'w', 'utf-8')
    f3 = codecs.open (args.file2 + "_[NG].txt" , 'w', 'utf-8')

    line = f1.readline().strip()

    while line:
        word_head,word_pos,word_definition,word_quote = get_translation( line )

        word_definition_space = " " + word_definition

        num = len(word_head)
        bar = ""

        for num in range(0, num):
            bar = bar + "_"

        pattern = re.compile(" " + word_head + " ", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + " ", word_definition_space)

        pattern = re.compile(" " + word_head + ",", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + ",", question)

        pattern = re.compile(" " + word_head + "\.", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + ".", question)

        pattern = re.compile(" " + word_head + "s", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "s", question)

        pattern = re.compile(" " + word_head + "es", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "es", question)

        pattern = re.compile(" " + word_head + "ing", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "ing", question)

        pattern = re.compile(" " + word_head + "ed", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "ed", question)

        pattern = re.compile(" " + "'" + word_head + "'", re.IGNORECASE)
        question = re.sub(pattern, " " + "'" + bar + "'", question)

        pattern = re.compile(" " + "'" + word_head + "!'", re.IGNORECASE)
        question = re.sub(pattern, " " + "'" + bar + "!'", question)

        pattern = re.compile(" " + word_head[0:-1] + "ed", re.IGNORECASE)
        question = re.sub(pattern, " " + bar[0:-1] + "ed", question)

        pattern = re.compile(" " + word_head[0:-1] + "ing", re.IGNORECASE)
        question = re.sub(pattern, " " + bar[0:-1] + "ing", question)

        pattern = re.compile(" " + word_head[0:-1] + "ies", re.IGNORECASE)
        question = re.sub(pattern, " " + bar[0:-1] + "ies", question)

        pattern = re.compile(" " + word_head[0:-1] + "ied", re.IGNORECASE)
        question = re.sub(pattern, " " + bar[0:-1] + "ied", question)

        pattern = re.compile(" " + word_head + "\?", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "?", question)

        pattern = re.compile(" " + word_head + "!", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "!", question)

        pattern = re.compile(" " + word_head + word_head[-1] + "ing", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "_ing", question) 

        pattern = re.compile(" " + word_head + word_head[-1] + "ed", re.IGNORECASE)
        question = re.sub(pattern, " " + bar + "_ed", question) 

        if word_head == "foot":
            pattern = re.compile(" " + "feet" + " ", re.IGNORECASE)
            question = re.sub(pattern, " " + bar + " ", question)

        if word_head == "leaf":
            pattern = re.compile(" " + "leaves" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar + "es", question)

        if word_head == "tooth":
            pattern = re.compile(" " + "teeth" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar , question)

        if word_head == "lie":
            pattern = re.compile(" " + "lying" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar[0:-1] + "ing", question)

        if word_head == "countryman":
            pattern = re.compile(" " + "countrymen" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar , question)

        if word_head == "antenna":
            pattern = re.compile(" " + "antennae" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar + "_", question)

        if word_head == "mislead":
            pattern = re.compile(" " + "misled" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar[0:-1] , question)

        if word_head == "overthrow":
            pattern = re.compile(" " + "overthrown" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar + "_", question)

        if word_head == "hoof":
            pattern = re.compile(" " + "hooves" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar + "es", question)

        if word_head == "parenthesis":
            pattern = re.compile(" " + "parentheses" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar , question)

        if word_head == "alumnus":
            pattern = re.compile(" " + "alumni" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar[0:-1] , question)

        if word_head == "elf":
            pattern = re.compile(" " + "elves" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar + "es", question)

        if word_head == "narcissus":
            pattern = re.compile(" " + "narcissi" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar[0:-1], question)

        if word_head == "vie":
            pattern = re.compile(" " + "vying" , re.IGNORECASE)
            question = re.sub(pattern, " " + bar[0:-1] + "ing", question)


        question = question.lstrip()


        if args.full:
            print (word_head + " | " + word_pos + " | " + word_definition.strip().replace('\n',' ')+ " | " + word_quote.replace('\n',' ') + " | " + question.replace('\n',' '))
            f2.write(word_head + "\t" + word_pos + "\t" + word_definition.strip().replace('\n',' ') + "\t" + word_quote.replace('\n',' ') + "\t" + question.replace('\n',' ') + '\n')
        elif args.minimum:
            print (word_head + " | " + question.replace('\n',' '))
            if question != '(none)' and question.find('_') != -1:
                f2.write(question.replace('\n',' ') + "\t" + word_definition.strip().replace('\n',' ') + " [" + word_head + "]" + '\n')
            else:            
                f3.write(line.strip() + '\n')
        else:
            print (word_head + " | " + word_pos + " | " + word_definition.strip().replace('\n',' ')+ " | " + word_quote.replace('\n',' ') + " | " + question.replace('\n',' '))

        line = f1.readline().strip()

    f1.close
    f2.close
    f3.close

